import { Extension, EditorState, StateEffect } from "@codemirror/state";
import { KeyBinding } from "@codemirror/view";
import { Completion } from "./completion";
import { CompletionConfig } from "./config";
export { snippet, snippetCompletion, nextSnippetField, prevSnippetField, hasNextSnippetField, hasPrevSnippetField, clearSnippet, snippetKeymap } from "./snippet";
export { Completion, CompletionInfo, CompletionSection, CompletionContext, CompletionSource, CompletionResult, pickedCompletion, completeFromList, ifIn, ifNotIn, insertCompletionText } from "./completion";
export { startCompletion, closeCompletion, acceptCompletion, moveCompletionSelection } from "./view";
export { completeAnyWord } from "./word";
export { CloseBracketConfig, closeBrackets, closeBracketsKeymap, deleteBracketPair, insertBracket } from "./closebrackets";
export declare function autocompletion(config?: CompletionConfig): Extension;
export declare const completionKeymap: readonly KeyBinding[];
export declare function completionStatus(state: EditorState): null | "active" | "pending";
export declare function currentCompletions(state: EditorState): readonly Completion[];
export declare function selectedCompletion(state: EditorState): Completion | null;
export declare function selectedCompletionIndex(state: EditorState): number | null;
export declare function setSelectedCompletion(index: number): StateEffect<unknown>;
