import { EditorView, Command, ViewPlugin, ViewUpdate } from "@codemirror/view";
import { Transaction } from "@codemirror/state";
import { ActiveSource } from "./state";
import { CompletionResult, CompletionContext } from "./completion";
export declare function moveCompletionSelection(forward: boolean, by?: "option" | "page"): Command;
export declare const acceptCompletion: Command;
export declare const startCompletion: Command;
export declare const closeCompletion: Command;
declare class RunningQuery {
    readonly active: ActiveSource;
    readonly context: CompletionContext;
    time: number;
    updates: Transaction[];
    done: undefined | CompletionResult | null;
    constructor(active: ActiveSource, context: CompletionContext);
}
declare const enum CompositionState {
    None = 0,
    Started = 1,
    Changed = 2,
    ChangedAndMoved = 3
}
export declare const completionPlugin: ViewPlugin<{
    debounceUpdate: number;
    running: RunningQuery[];
    debounceAccept: number;
    pendingStart: boolean;
    composing: CompositionState;
    readonly view: EditorView;
    update(update: ViewUpdate): void;
    startUpdate(): void;
    startQuery(active: ActiveSource): void;
    scheduleAccept(): void;
    accept(): void;
}>;
export declare const commitCharacters: import("@codemirror/state").Extension;
export {};
